package com.bzd.web.controller.ddgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.ddgl.SDdglFpglDsfzfkpService;

import java.util.List;

/**
*
* 第三方支付开票表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "ddgl/sddglfpgldsfzfkp")
public class SDdglFpglDsfzfkpController extends BaseController {

    // 页面跳转前缀
    private String prefix = "ddgl";

    @Autowired
    private SDdglFpglDsfzfkpService sDdglFpglDsfzfkpService;

    /**
    * 第三方支付开票表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("ddgl:dd:view")
    @GetMapping("/sDdglFpglDsfzfkpAdd")
    public String add() {
        return prefix + "/SDdglFpglDsfzfkpAdd";
    }

    /**
    * 第三方支付开票表 新增
    *
    * @return
    */
    @Log(title = "第三方支付开票表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sDdglFpglDsfzfkpAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sDdglFpglDsfzfkpService.addSDdglFpglDsfzfkp(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 第三方支付开票表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("ddgl:dd:view")
    @GetMapping("/sDdglFpglDsfzfkpView")
    public String sddglfpgldsfzfkpListView() {
        return prefix + "/SDdglFpglDsfzfkpList";
    }

    /**
    * 第三方支付开票表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:sDdglFpglDsfzfkpList")
    @PostMapping("/sDdglFpglDsfzfkpList")
    @ResponseBody
    public TableDataInfo sddglfpgldsfzfkpList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sDdglFpglDsfzfkpService.findSDdglFpglDsfzfkpList(pd);
        return getDataTable(pageData);
    }

    /**
    * 第三方支付开票表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:remove")
    @Log(title = "第三方支付开票表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sDdglFpglDsfzfkpRemove")
    @ResponseBody
    public AjaxResult sddglfpgldsfzfkpRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sDdglFpglDsfzfkpService.SDdglFpglDsfzfkpRemove(pd);
        return toAjax(integer);
    }

    /**
    * 第三方支付开票表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:edit")
    @GetMapping("/sDdglFpglDsfzfkpEdit/{id}")
    public String sddglfpgldsfzfkpView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sDdglFpglDsfzfkpService.findSDdglFpglDsfzfkpList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sddglfpgldsfzfkpPageEdit";
        }
        return prefix+ "/sddglfpgldsfzfkpEdit";
    }

    /**
    * 第三方支付开票表保存修改的数据
    */
    @RequiresPermissions("ddgl:dd:edit")
    @Log(title = "第三方支付开票表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sDdglFpglDsfzfkpEdit")
    @ResponseBody
    public AjaxResult sddglfpgldsfzfkpEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sDdglFpglDsfzfkpService.updateSDdglFpglDsfzfkp(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sddglfpgldsfzfkp with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sddglfpgldsfzfkp with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
